/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Googlebar for Mozilla.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Boughton
 *  Andrew Houghton
 *  John Woods
 *  Bernd Kuemmerlen
 *  Robert Mulcahy
 *  Alfred Kayser
 *  Reflex
 *  Gary Turnbull
 *  Raj Bhaskar
 *  Joachim Thewes
 *  Henrik Gemal
 *  Robert Fernandes
 *  Joe Chellman
 *  Franki Cheung
 *  Alban Fonrouge
 *  Martin Hassman
 *  Ufuk Kayserilioglu
 *  Yoni Gilad
 *  Tim Schmidt
 *  timeless
 *  Francis Turner
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var myGooglebarNavigation = {
	mLastResultIndx: -99,
	mLastResults: new Array(),
	mLastGoogle: null,
	
	checkLocation: function(aUrl) {
		for (var i = 0; i < this.mLastResults.length; i++) {
			if (this.mLastResults[i] == aUrl) {
				setTimeout("myGooglebarNavigation.checkNavigation(" + i + ")", 100);
				return true;
			}
		}
		
		return false;
	},
	
	checkNavigation: function(aResultIndx) {
	    if (!window._content.document) {
	        return;
	    }
	    
	    var prevBtn = myGooglebarUtil.getElement("ggb_PrevButton");
	    var nextBtn = myGooglebarUtil.getElement("ggb_NextButton");
	    var prevBtnPop = myGooglebarUtil.getElement("ggb_PrevButtonPopup");
	    var nextBtnPop = myGooglebarUtil.getElement("ggb_NextButtonPopup");
		var ndx;
		
		// clean up all of the popup menu items
		for (ndx = prevBtnPop.childNodes.length - 1; ndx >= 0; ndx--) {
			prevBtnPop.removeChild(prevBtnPop.childNodes[ndx]);
		}
		for (ndx = nextBtnPop.childNodes.length - 1; ndx >= 0; ndx--) {
			nextBtnPop.removeChild(nextBtnPop.childNodes[ndx]);
		} 
	
	    // if we didn't find a match then disable both buttons and return
	    if (aResultIndx == null || aResultIndx < -1) {
	        prevBtn.setAttribute("disabled", true);
	        prevBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.prev.tooltip"));
	        nextBtn.setAttribute("disabled", true);
	        nextBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.next.tooltip"));
	        return;
	    }
	    /*
	    else if (this.mLastResultIndx == aResultIndx) {
	    	return;
	    }
	    */
	    else {
	    	this.mLastResultIndx = aResultIndx;
	    }
	
	    // the oncommand attribute must be REMOVED because if
	    // the button is disabled it should take no action and
	    // if it is already set you can't just set it again,
	    // for some reason that has no effect so you have to
	    // remove the attribute and add it again
	    // prevBtn.removeAttribute("oncommand");
	    // nextBtn.removeAttribute("oncommand");
	    
	    var loc;
	    var tempNode;
	
	    // previous navigation
	    if (this.mLastResultIndx <= 0) {
	        prevBtn.setAttribute("disabled", true);
	        prevBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.prev.tooltip"));
	    }
	    else {
		    ndx = this.mLastResultIndx - 1;
	        loc = this.mLastResults[ndx];
	        prevBtn.setAttribute("disabled", false);
	        prevBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.prev.tooltip") + " - " + loc);
	        prevBtn.setAttribute("oncommand", "myGooglebarNavigation.navGo(event, 'ggb_PrevButtonPopup');");
	        
	        for (ndx = this.mLastResultIndx - 1; ndx >= 0; ndx--) {
	        	loc = this.mLastResults[ndx];
	            tempNode = document.createElement("menuitem");
	            tempNode.setAttribute("label", (ndx + 1) + " - " + loc);
	            tempNode.setAttribute("tooltiptext", loc);
	            tempNode.setAttribute("class", "ggb_css_menuitem_all");
	            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + loc + "', " + ndx + "); event.preventBubble();");
	            tempNode.setAttribute("nav-loc", loc);
	            tempNode.setAttribute("nav-ndx", ndx);
	            prevBtnPop.appendChild(tempNode);
	        }
	    }
	
	    // next navigation
	    if (this.mLastResultIndx == this.mLastResults.length - 1) {
	        nextBtn.setAttribute("disabled", true);
	        nextBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.next.tooltip"));
	    }
	    else {
	    	ndx = this.mLastResultIndx + 1;
	        loc = this.mLastResults[ndx];
	        nextBtn.setAttribute("disabled", false);
	        nextBtn.setAttribute("tooltiptext", myGooglebarUtil.getProperty("gb.button.nav.next.tooltip") + " - " + loc);
	        nextBtn.setAttribute("oncommand", "myGooglebarNavigation.navGo(event, 'ggb_NextButtonPopup');");
	        
	        for (ndx = this.mLastResultIndx + 1; ndx < this.mLastResults.length; ndx++) {
	        	loc = this.mLastResults[ndx];
	            tempNode = document.createElement("menuitem");
	            tempNode.setAttribute("label", (ndx + 1) + " - " + loc);
	            tempNode.setAttribute("tooltiptext", loc);
	            tempNode.setAttribute("class", "ggb_css_menuitem_all");
	            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + loc + "', " + ndx + "); event.preventBubble();");
	            tempNode.setAttribute("nav-loc", loc);
	            tempNode.setAttribute("nav-ndx", ndx);            
	            nextBtnPop.appendChild(tempNode);
	        }
	    }
	},
	
	customNavigation: function() {
	    if (!window._content.document) {
	        return;
	    }
	
	    var url = window._content.document.location;
	    var doc = window._content.document.documentElement;
	    var elems = doc.getElementsByTagName("A");
	    var curr, last;
	
	    var i = 0;
	    var count = 0;
	
		// Don't retrieve back to back duplicate links
	
	    for (i = 0; i < elems.length; i++) {
	        curr = myGooglebarUtil.getAnchorURL(elems[i], url)
	        if (curr && last != curr) {
	        	last = curr;
	            count++;
	        }
	    }
	
	    if (count > 0) {
	        this.mLastResults = new Array(count);
	    }
	    else {
	        this.mLastResults = new Array(0);
	        myGooglebarNavigation.checkNavigation(-99);
	        return;
	    }
	
	    count = 0;
	
	    for (i = 0; i < elems.length; i++) {
	    	curr = myGooglebarUtil.getAnchorURL(elems[i], url);
	        if (curr && last != curr) {
	        	last = curr;
	            this.mLastResults[count] = curr;
	            count++;
	        }
	    }
	
	    // also populate the last google result and set up the button appropriately
	    this.mLastGoogle = url;
	
	    var lastBtn = myGooglebarUtil.getElement("ggb_LastButton");
	    var lastBtnPop = myGooglebarUtil.getElement("ggb_LastButtonPopup");
	    lastBtn.removeAttribute("oncommand");
	    lastBtn.setAttribute("disabled", false);
	    lastBtn.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");
	
		// clean up all of the popup menu items
		for (i = lastBtnPop.childNodes.length - 1; i >= 0; i--) {
			lastBtnPop.removeChild(lastBtnPop.childNodes[i]);
		}
	    
	    setTimeout("myGooglebarNavigation.checkNavigation(-1)", 100);
	},
	
	loadResults: function() {
	    if (!window._content.document) {
	        return;
	    }
	
		var url = window._content.document.location;

		var deskRegex = new RegExp("^" + myGooglebarPrefUtil.getPrefValue(GB_PREF_DESKTOP_URL_NAME) + ".*");
		if (deskRegex.test(url)) {
		   	this.loadDesktopResults();
		}
	    else if (/^http:\/\/[^\.]*?\.google\..*?\/[^\?]*?(?:\?q=|\?.*?&q=)([^&]*)&?.*/i.test(url)) {
			this.loadGoogleResults();
	    }
	},

	loadDesktopResults: function() {
        var doc = window._content.document;
        var bodyElem = doc.getElementsByTagName("BODY")[0];
        var tableElems = new Array();
        var aElem;

		this.loadNavResults();

        var i = 0;
        var count = 0;
        var ignore = 4;

        for (i = 0; i < bodyElem.childNodes.length; i++) {
            if (bodyElem.childNodes[i].nodeName == "TABLE") {
                if (count >= ignore) {
                	tableElems[count - ignore] = bodyElem.childNodes[i];
                }
				count++;
            }
        }
        
        count = tableElems.length;

        if (count > 0) {
            this.mLastResults = new Array(count);
        }
        else {
            this.mLastResults = new Array(0);
            return;
        }

        for (i = 0; i < tableElems.length; i++) {
            aElem = tableElems[i].getElementsByTagName("A")[0];
            this.mLastResults[i] = myGooglebarPrefUtil.getPrefValue(GB_PREF_DESKTOP_URL_NAME) + aElem.getAttribute("href").substring(1);
        }

        setTimeout("myGooglebarNavigation.checkNavigation(-1)", 100);
	},

	loadGoogleResults: function() {
        // Must have just loaded a google query result page
        // so lets repopulate the array of last results.
        //
        // In a Google query result page all of the results
        // are under HTML paragraph elements "P" with a class
        // attribute of "g".  The first URL (child element "A")
        // is the actual result that we care about.
        var doc = window._content.document;
        var pElems = doc.getElementsByTagName("P");
        var aElems;

		this.loadNavResults();

        var i = 0;
        var count = 0;

        for (i = 0; i < pElems.length; i++) {
            if (pElems[i].getAttribute("class") == "g") {
                count++;
            }
        }

        if (count > 0) {
            this.mLastResults = new Array(count);
        }
        else {
            this.mLastResults = new Array(0);
            return;
        }

        count = 0;

        for (i = 0; i < pElems.length; i++) {
            if (pElems[i].getAttribute("class") == "g") {
                aElems = pElems[i].getElementsByTagName("A");
                if (aElems.length > 0) {
                    this.mLastResults[count] = aElems[0].getAttribute("href");
                }
                count++;
            }
        }

        setTimeout("myGooglebarNavigation.checkNavigation(-1)", 100);
	},
	
	loadNavResults: function() {
		var url = window._content.document.location;
		var doc = window._content.document;
		
		// also populate the last google result and set up the button appropriately
        this.mLastGoogle = url;

        var lastBtn = myGooglebarUtil.getElement("ggb_LastButton");
        var lastBtnPop = myGooglebarUtil.getElement("ggb_LastButtonPopup");
        lastBtn.removeAttribute("oncommand");
        lastBtn.setAttribute("disabled", false);
        lastBtn.setAttribute("onclick", "if (event.button == 1) { myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble(); }");
        lastBtn.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");

		// clean up all of the popup menu items
		for (i = lastBtnPop.childNodes.length - 1; i >= 0; i--) {
			lastBtnPop.removeChild(lastBtnPop.childNodes[i]);
		}
		
        var divElems = doc.getElementsByTagName("div");
        var divElem;
        
        var i;

        for (i = 0; i < divElems.length; i++) {
            if (divElems[i].getAttribute("class") == "n") {
                divElem = divElems[i];
                break;
            }
        }

	    if (divElem) {
	        var urlRoot = url.toString().substring(0, url.toString().lastIndexOf("/"));
	        var imgElems = divElem.getElementsByTagName("img");
	        var imgSrc;
	        var page;
	        var tempNode;
	        
			for (i = 0; i < imgElems.length; i++) {
				imgSrc = imgElems[i].getAttribute("src");

				if (imgSrc.indexOf("nav_previous") >= 0) {
					url = urlRoot + imgElems[i].parentNode.getAttribute("href");
					tempNode = document.createElement("menuitem");
		            tempNode.setAttribute("label", "Previous Result Page");
		            tempNode.setAttribute("tooltiptext", "Previous Result Page");
		            tempNode.setAttribute("class", "ggb_css_menuitem_all");
		            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");
		            lastBtnPop.appendChild(tempNode);
		            lastBtnPop.appendChild(document.createElement("menuseparator"));				
				}
				else if (imgSrc.indexOf("nav_current") >= 0) {
					url = this.mLastGoogle;
					
					page = imgElems[i].parentNode.getElementsByTagName("span")[0].firstChild.nodeValue;
					if (!page) {
						// Desktop search has an extra font tag
						page = imgElems[i].parentNode.getElementsByTagName("span")[0].firstChild.firstChild.nodeValue;
					}
					
					tempNode = document.createElement("menuitem");
		            tempNode.setAttribute("label", "Result Page " + page);
		            tempNode.setAttribute("tooltiptext", "Result Page " + page);
		            tempNode.setAttribute("class", "ggb_css_menuitem_all");
		            tempNode.setAttribute("type", "checkbox");
		            tempNode.setAttribute("checked", "true");
		            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");
		            lastBtnPop.appendChild(tempNode);	            
				}
				else if (imgSrc.indexOf("nav_page") >= 0) {
					url = urlRoot + imgElems[i].parentNode.getAttribute("href");
					page = imgElems[i].parentNode.childNodes[2].nodeValue;
					tempNode = document.createElement("menuitem");
		            tempNode.setAttribute("label", "Result Page " + page);
		            tempNode.setAttribute("tooltiptext", "Result Page " + page);
		            tempNode.setAttribute("class", "ggb_css_menuitem_all");
		            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");
		            lastBtnPop.appendChild(tempNode);	            
				}
				else if (imgSrc.indexOf("nav_next") >= 0) {
					url = urlRoot + imgElems[i].parentNode.getAttribute("href");
					lastBtnPop.appendChild(document.createElement("menuseparator"));	
					tempNode = document.createElement("menuitem");
		            tempNode.setAttribute("label", "Next Result Page");
		            tempNode.setAttribute("tooltiptext", "Next Result Page");
		            tempNode.setAttribute("class", "ggb_css_menuitem_all");
		            tempNode.setAttribute("oncommand", "myGooglebarNavigation.navGoMenu(event, '" + url + "', -1); event.preventBubble();");
		            lastBtnPop.appendChild(tempNode);	            
				}
			}
	    }
	},
	
	navGo: function(aEvent, aSource) {
	    var navContainer = myGooglebarUtil.getElement(aSource);
	
	    if (navContainer && navContainer.getElementsByTagName("menuitem").length > 0) {
	    	var tempNode = navContainer.getElementsByTagName("menuitem")[0];
	        this.navGoMenu(aEvent, tempNode.getAttribute("nav-loc"), parseInt(tempNode.getAttribute("nav-ndx")));
	    }
	},
	
	navGoMenu: function(aEvent, aAddy, aResultIndx) {
	    myGooglebar.doAction(aAddy, myGooglebar.getLocFromEvent(aEvent));
	    setTimeout("myGooglebarNavigation.checkNavigation(" + aResultIndx + ")", 100);
	}
};
 